<template>
  <div id="app" class="layout">
    <header class="header">
      <b-navbar-brand>
        <router-link to="/">
          <img
            class="brand-image"
            alt="OPEN-CUTS logo"
            src="@/assets/logo.svg"
          />
          {{ title }}
        </router-link>
      </b-navbar-brand>
      <b-navbar toggleable="md" type="light" align="end">
        <b-navbar-toggle target="nav-item-collapse" />

        <b-collapse id="nav-item-collapse" is-nav>
          <b-navbar-nav>
            <b-nav-item to="/report">
              Report
              <b-icon-clipboard-data />
            </b-nav-item>

            <b-nav-item to="/login" v-if="!getToken()">
              Log in
              <b-icon-box-arrow-in-right />
            </b-nav-item>

            <b-nav-item to="/register" v-if="!getToken()">
              Register
              <b-icon-person-plus-fill />
            </b-nav-item>

            <b-nav-item to="/account" v-if="getToken()">
              My account
              <b-icon-person-fill />
            </b-nav-item>

            <b-nav-item to="/help">
              Help
              <b-icon-question-circle />
            </b-nav-item>
          </b-navbar-nav>
        </b-collapse>
      </b-navbar>
    </header>

    <b-modal
      title="Login error"
      ok-title="Logout"
      cancel-title="Cancel"
      :visible="loginError"
      @ok="logout"
      @cancel="retry"
    >
      <p class="my-4">
        Your API token seems to be invalid. Please log in again!
      </p>
    </b-modal>

    <router-view />

    <div class="footer">
      <p class="text-center">
        <a href="https://www.open-cuts.org" target="_blank" rel="noopener"
          >OPEN-CUTS</a
        >
        is free software licensed under the terms of the
        <a
          href="https://www.open-cuts.org/LICENSE"
          target="_blank"
          rel="noopener"
          >GNU AGPL version 3.0 or later</a
        >.
      </p>
      <p class="text-center">
        OPEN-CUTS is still <b>very much in development</b>. If you're even
        <i>thinking</i> of using this in production, you're <i>crazy</i>.
      </p>
      <p class="text-center footer-links">
        <a :href="authorLink" target="_blank" rel="noopener">
          (c) {{ new Date().getFullYear() }} {{ author }}
        </a>
        <router-link to="/privacy">privacy policy</router-link>
        <a
          href="https://www.open-cuts.org/source"
          target="_blank"
          rel="noopener"
        >
          source code
        </a>
        <router-link to="/help">help</router-link>
      </p>
    </div>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  data() {
    return {
      title: process.env.VUE_APP_TITLE || "OPEN-CUTS",
      author: process.env.VUE_APP_AUTHOR || "Jan Sprinz",
      authorLink:
        process.env.VUE_APP_AUTHOR_LINK || "https://www.open-cuts.org",
      api: process.env.VUE_APP_APIURL,
      loginError: false
    };
  },
  methods: {
    getToken() {
      return localStorage.getItem("OC_AUTH_TOKEN") || null;
    },
    validateToken() {
      return this.$apollo
        .query({
          query: gql`
            query {
              me {
                id
                name
                groups
                email
                joined
              }
            }
          `
        })
        .then(r => {
          if (!r?.data?.me) this.loginError = true;
        })
        .catch(() => {
          this.loginError = true;
        });
    },
    retry() {
      window.location.reload();
    },
    logout() {
      localStorage.removeItem("OC_AUTH_TOKEN");
      window.location.href = "/login";
    }
  },
  mounted() {
    if (this.getToken() && !this.$apollo.loading) this.validateToken();
  }
};
</script>
